<template>
  <a-card
    :bordered="false"
    :body-style="{ padding: '0px' }"
    class="table-page-search-wrapper"
  >
    <a-form :form="form" style="padding: 24px 32px 0px 32px;">
      <a-row :gutter="48">
        <a-col :md="(!advanced && 18) || 24" :sm="24">
          <a-form-item v-bind="formItemLayout" label="Tìm theo tên: ">
            <a-input
              v-decorator="['name', formItemOption.name]"
              type="text"
            />
          </a-form-item>
        </a-col>
        <template v-if="advanced">
          <a-col :md="(!advanced && 18) || 24" :sm="24">
            <a-form-item v-bind="formItemLayout" label="Tìm theo email: ">
              <a-input
                v-decorator="['email', formItemOption.email]"
                type="text"
              />
            </a-form-item>
          </a-col>
          <a-col :span="24">
            <a-form-item v-bind="formItemLayout" label="Tìm theo trạng thái : ">
              <a-select
                v-decorator="['status', formItemOption.status]"
                :get-popup-container="triggerNode => triggerNode.parentNode"
              >
                <a-icon slot="suffixIcon" type="caret-down" class="srp-darkest" />
                <a-select-option v-for="s in stt" :key="s">
                  {{ s | UserStatus }}
                </a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
          <a-col v-if="isAdmin" :span="24">
            <a-form-item v-bind="formItemLayout" label="Giám sát viên : ">
              <a-select
                v-decorator="['supervisorId', formItemOption.supervisorId]"
                :get-popup-container="triggerNode => triggerNode.parentNode"
              >
                <a-icon slot="suffixIcon" type="caret-down" class="srp-darkest" />
                <a-select-option v-for="s in supervisors" :key="s.id" :value="s.id">
                  {{ s.gender | NamePrefix }}{{ s.name }}
                </a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
        </template>

        <a-col :md="(!advanced && 6) || 24" :sm="24">
          <a-row>
            <a-col v-if="advanced" :span="12" />
            <a-col :span="12">
              <span
                :style="(advanced && { float: 'right', overflow: 'hidden' }) || {}"
                class="table-page-search-submitButtons"
              >
                <a-button @click.stop.prevent="handleSearch" type="primary">
                  Tìm kiếm
                </a-button>
                <a @click="toggleAdvanced" style="margin-left: 8px">
                  {{ advanced ? 'Rút gọn' : 'Tìm nâng cao' }}
                  <a-icon :type="advanced ? 'up' : 'down'" />
                </a>
              </span>
            </a-col>
          </a-row>
        </a-col>
      </a-row>
    </a-form>

    <div class="c-search-conditions">
      <div v-if="hasCondition" class="c-search-conditions__group">
        <span class="c-search-conditions__group-head">Tìm kiếm</span>
        <div class="c-search-conditions__group-body">
          <span
            v-if="queryParam.name"
            class="c-search-conditions__item"
          >
            <span class="c-search-conditions__item-title">Tên: </span>
            {{ queryParam.name }}
          </span>
          <span
            v-if="queryParam.email"
            class="c-search-conditions__item"
          >
            <span class="c-search-conditions__item-title">Email: </span>
            {{ queryParam.email }}
          </span>
          <span
            v-if="queryParam.status"
            class="c-search-conditions__item"
          >
            <span class="c-search-conditions__item-title">Trạng thái: </span>
            {{ queryParam.status | UserStatus }}
          </span>
          <span
            v-if="queryParam.supervisorId && isAdmin"
            class="c-search-conditions__item"
          >
            <span class="c-search-conditions__item-title">Giám sát viên: </span>
            {{ getSupervisor(+queryParam.supervisorId).name }}
          </span>
        </div>
      </div>
      <span style="flex: 1" />
      <a-button @click="clearSearch" type="link">
        Thiết lập lại
      </a-button>
    </div>
  </a-card>
</template>

<script>
import { standardizedParmas } from '@/utils/util'
import { mapGetters } from 'vuex'
import { ehrApi } from '@/api'
export default {
  data () {
    return {
      advanced: false,
      jobs: [],
      nextToken: null,
      value: null,
      queryParam: {},
      supervisors: [],
      stt: [
        'ACTIVE',
        'INACTIVE'
      ]
    }
  },
  computed: {
    ...mapGetters('auth', ['userId', 'role', 'isAdmin']),
    formItemLayout: () => ({
      colon: false,
      labelCol: {
        sm: { span: 24 },
        md: { span: 3 }
      },
      wrapperCol: {
        sm: { span: 24 },
        md: { span: 21 }
      }
    }),
    formItemOption () {
      const { query } = this.$route
      return {
        name: {
          initialValue: query.name || ''
        },
        email: {
          initialValue: query.email || null
        },
        status: {
          initialValue: query.status || null
        },
        supervisorId: {
          initialValue: +query.supervisorId || null
        }
      }
    },
    hasCondition () {
      const res = Object.keys(this.queryParam).some(
        k => this.queryParam[k] && k !== 'org'
      )
      return res
    }
  },
  watch: {
    '$route.query': {
      handler (newValue, oldValue) {
        this.queryParam = { ...this.$route.query }
      },
      immediate: true
    }
  },
  beforeCreate () {
    this.form = this.$form.createForm(this, { first: true })
  },
  async created () {
    if (this.isAdmin) {
      const filter = {
        where: {},
        limit: 1000,
        order: 'name ASC'
      }
      const { data } = await ehrApi.admin.getSupervisors({ filter })
      this.supervisors = data
    }
  },
  methods: {
    getSupervisor (id) {
      const spv = this.supervisors.find(sp => sp.id === id)
      return spv || {}
    },
    clearSearch () {
      this.queryParam = {}
      this.form.resetFields()
      this.$router.push({ path: '/supporters', query: {} })
    },
    toggleAdvanced () {
      this.advanced = !this.advanced
    },
    handleSearch () {
      this.form.validateFields((error, values) => {
        if (!error) {
          const query = standardizedParmas({
            ...this.$route.query,
            ...values
          })
          this.$router.push({ path: '/supporters', query })
        }
      })
    }
  }
}
</script>
<style lang="less" scoped>
.c-search-conditions {
  background: #fafafa;
  border-top: 1px solid #e8e8e8;
  align-items: center;
  padding: 8px 16px;
  display: flex;
  .c-search-conditions__group {
    display: flex;
    .c-search-conditions__group-head {
      font-size: 12px;
      line-height: 1.25;
      display: table-cell;
      vertical-align: top;
      width: 75px;
      font-weight: 600;
      line-height: 1.82;
    }
    .c-search-conditions__item {
      margin: 0 0 0 15px;
      .c-search-conditions__item-title {
        font-weight: 600;
      }
    }
  }
}
</style>
